std::multimap(3)

NAME
std::multimap -

SYNOPSIS

Detailed Description

  template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> class std::multimap< _Key, _Tp, _Compare, _Alloc >
Meets the requirements of a container, a reversible container, and an associative container (using equivalent keys). For a multimap<Key,T> the key_type is Key, the mapped_type is T, and the value_type is std::pair<const Key,T>.

Multimaps support bidirectional iterators.

Definition at line 107 of file stl_multimap.h.

  Public Types
typedef _Alloc allocator_type
typedef _Rep_type::const_iterator const_iterator
typedef _Pair_alloc_type::const_pointer const_pointer
typedef _Pair_alloc_type::const_reference const_reference
typedef _Rep_type::const_reverse_iterator const_reverse_iterator
typedef _Rep_type::difference_type difference_type
typedef _Rep_type::iterator iterator
typedef _Compare key_compare
typedef _Key key_type
typedef _Tp mapped_type
typedef _Pair_alloc_type::pointer pointer
typedef _Pair_alloc_type::reference reference
typedef _Rep_type::reverse_iterator reverse_iterator
typedef _Rep_type::size_type size_type
typedef std::pair< const _Key, _Tp > value_type

  Public Member Functions
const_iterator begin () const
iterator begin ()
void clear ()
size_type count (const key_type &__x) const
bool empty () const
const_iterator end () const
iterator end ()
std::pair< const_iterator, const_iterator > equal_range (const key_type &__x) const
std::pair< iterator, iterator > equal_range (const key_type &__x)
void erase (iterator __first, iterator __last)
size_type erase (const key_type &__x)
void erase (iterator __position)
const_iterator find (const key_type &__x) const
iterator find (const key_type &__x)
allocator_type get_allocator () const
template<typename _InputIterator> void insert (_InputIterator __first, _InputIterator __last)
iterator insert (iterator __position, const value_type &__x)
iterator insert (const value_type &__x)
key_compare key_comp () const
const_iterator lower_bound (const key_type &__x) const
iterator lower_bound (const key_type &__x)
size_type max_size () const
template<typename _InputIterator> multimap (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
template<typename _InputIterator> multimap (_InputIterator __first, _InputIterator __last)
multimap (const multimap &__x)
multimap (const _Compare &__comp, const allocator_type &__a=allocator_type())
multimap ()
multimap & operator= (const multimap &__x)
const_reverse_iterator rbegin () const
reverse_iterator rbegin ()
const_reverse_iterator rend () const
reverse_iterator rend ()
size_type size () const
void swap (multimap &__x)
const_iterator upper_bound (const key_type &__x) const
iterator upper_bound (const key_type &__x)
value_compare value_comp () const

  Friends
template<typename _K1, typename _T1, typename _C1, typename _A1> bool operator< (const multimap< _K1, _T1, _C1, _A1 > &, const multimap< _K1, _T1, _C1, _A1 > &)
template<typename _K1, typename _T1, typename _C1, typename _A1> bool operator== (const multimap< _K1, _T1, _C1, _A1 > &, const multimap< _K1, _T1, _C1, _A1 > &)

  Classes
class value_compare

Constructor & Destructor Documentation

  multimap () [inline]

Default constructor creates no elements.

Definition at line 169 of file stl_multimap.h.

  multimap (const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline, explicit]

Default constructor creates no elements.

Definition at line 177 of file stl_multimap.h.

  multimap (const multimap< _Key, _Tp, _Compare, _Alloc > & __x) [inline]

Multimap copy constructor.

Parameters:
    x A multimap of identical element and allocator types.

The newly-created multimap uses a copy of the allocation object used by x.

Definition at line 188 of file stl_multimap.h.

  multimap (_InputIterator __first, _InputIterator __last) [inline]

Builds a multimap from a range.

Parameters:
    first An input iterator.
    last An input iterator.

Create a multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 201 of file stl_multimap.h.

  multimap (_InputIterator __first, _InputIterator __last, const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline]

Builds a multimap from a range.

Parameters:
    first An input iterator.
    last An input iterator.
    comp A comparison functor.
    a An allocator object.

Create a multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 217 of file stl_multimap.h.

Member Function Documentation

  const_iterator begin () const [inline]

Returns a read-only (constant) iterator that points to the first pair in the multimap. Iteration is done in ascending order according to the keys.

Definition at line 267 of file stl_multimap.h.

  iterator begin () [inline]

Returns a read/write iterator that points to the first pair in the multimap. Iteration is done in ascending order according to the keys.

Definition at line 258 of file stl_multimap.h.

  void clear () [inline]

Erases all elements in a multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 460 of file stl_multimap.h.

  size_type count (const key_type & __x) const [inline]

Finds the number of elements with given key.

Parameters:
    x Key of (key, value) pairs to be located.

Returns:
    Number of elements with specified key.

Definition at line 517 of file stl_multimap.h.

  bool empty () const [inline]

Returns true if the multimap is empty.

Definition at line 327 of file stl_multimap.h.

  const_iterator end () const [inline]

Returns a read-only (constant) iterator that points one past the last pair in the multimap. Iteration is done in ascending order according to the keys.

Definition at line 285 of file stl_multimap.h.

  iterator end () [inline]

Returns a read/write iterator that points one past the last pair in the multimap. Iteration is done in ascending order according to the keys.

Definition at line 276 of file stl_multimap.h.

  std::pair<const_iterator, const_iterator> equal_range (const key_type & __x) const [inline]

Finds a subsequence matching given key.

Parameters:
    x Key of (key, value) pairs to be located.

Returns:
    Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function is equivalent to

    std::make_pair(c.lower_bound(val),
                   c.upper_bound(val))

 (but is faster than making the calls separately).

Definition at line 601 of file stl_multimap.h.

  std::pair<iterator, iterator> equal_range (const key_type & __x) [inline]

Finds a subsequence matching given key.

Parameters:
    x Key of (key, value) pairs to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

    std::make_pair(c.lower_bound(val),
                   c.upper_bound(val))

 (but is faster than making the calls separately).

Definition at line 584 of file stl_multimap.h.

  void erase (iterator __first, iterator __last) [inline]

Erases a [first,last) range of elements from a multimap.

Parameters:
    first Iterator pointing to the start of the range to be erased.
    last Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 435 of file stl_multimap.h.

  size_type erase (const key_type & __x) [inline]

Erases elements according to the provided key.

Parameters:
    x Key of element to be erased.

Returns:
    The number of elements erased.

This function erases all elements located by the given key from a multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 420 of file stl_multimap.h.

  void erase (iterator __position) [inline]

Erases an element from a multimap.

Parameters:
    position An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 405 of file stl_multimap.h.

  const_iterator find (const key_type & __x) const [inline]

Tries to locate an element in a multimap.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 508 of file stl_multimap.h.

  iterator find (const key_type & __x) [inline]

Tries to locate an element in a multimap.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 493 of file stl_multimap.h.

  allocator_type get_allocator () const [inline]

Get a copy of the memory allocation object.

Definition at line 248 of file stl_multimap.h.

References _Rb_tree::get_allocator().

  void insert (_InputIterator __first, _InputIterator __last) [inline]

A template function that attemps to insert a range of elements.

Parameters:
    first Iterator pointing to the start of the range to be inserted.
    last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 391 of file stl_multimap.h.

  iterator insert (iterator __position, const value_type & __x) [inline]

Inserts a std::pair into the multimap.

Parameters:
    position An iterator that serves as a hint as to where the pair should be inserted.
    x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the multimap. Contrary to a std::map the multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on 'hinting'.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 378 of file stl_multimap.h.

  iterator insert (const value_type & __x) [inline]

Inserts a std::pair into the multimap.

Parameters:
    x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the multimap. Contrary to a std::map the multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted.

Insertion requires logarithmic time.

Definition at line 354 of file stl_multimap.h.

  key_compare key_comp () const [inline]

Returns the key comparison object out of which the multimap was constructed.

Definition at line 469 of file stl_multimap.h.

  const_iterator lower_bound (const key_type & __x) const [inline]

Finds the beginning of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Read-only (constant) iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful the iterator will point to the next greatest element or, if no such greater element exists, to end().

Definition at line 547 of file stl_multimap.h.

  iterator lower_bound (const key_type & __x) [inline]

Finds the beginning of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 532 of file stl_multimap.h.

  size_type max_size () const [inline]

Returns the maximum size of the multimap.

Definition at line 337 of file stl_multimap.h.

  multimap& operator= (const multimap< _Key, _Tp, _Compare, _Alloc > & __x) [inline]

Multimap assignment operator.

Parameters:
    x A multimap of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 240 of file stl_multimap.h.

References multimap::_M_t.

  const_reverse_iterator rbegin () const [inline]

Returns a read-only (constant) reverse iterator that points to the last pair in the multimap. Iteration is done in descending order according to the keys.

Definition at line 303 of file stl_multimap.h.

  reverse_iterator rbegin () [inline]

Returns a read/write reverse iterator that points to the last pair in the multimap. Iteration is done in descending order according to the keys.

Definition at line 294 of file stl_multimap.h.

  const_reverse_iterator rend () const [inline]

Returns a read-only (constant) reverse iterator that points to one before the first pair in the multimap. Iteration is done in descending order according to the keys.

Definition at line 321 of file stl_multimap.h.

  reverse_iterator rend () [inline]

Returns a read/write reverse iterator that points to one before the first pair in the multimap. Iteration is done in descending order according to the keys.

Definition at line 312 of file stl_multimap.h.

  size_type size () const [inline]

Returns the size of the multimap.

Definition at line 332 of file stl_multimap.h.

  void swap (multimap< _Key, _Tp, _Compare, _Alloc > & __x) [inline]

Swaps data with another multimap.

Parameters:
    x A multimap of the same element and allocator types.

This exchanges the elements between two multimaps in constant time. (It is only swapping a pointer, an integer, and an instance of the Compare type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 450 of file stl_multimap.h.

References multimap::_M_t.

Referenced by std::swap().

  const_iterator upper_bound (const key_type & __x) const [inline]

Finds the end of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Read-only (constant) iterator pointing to first iterator greater than key, or end().

Definition at line 567 of file stl_multimap.h.

  iterator upper_bound (const key_type & __x) [inline]

Finds the end of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Iterator pointing to the first element greater than key, or end().

Definition at line 557 of file stl_multimap.h.

  value_compare value_comp () const [inline]

Returns a value comparison object, built from the key comparison object out of which the multimap was constructed.

Definition at line 477 of file stl_multimap.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.